<?php
namespace Ak\Image\Processor\Adapter;

use Laminas\ServiceManager\AbstractPluginManager;
use Laminas\ServiceManager\Factory\InvokableFactory;

/**
 * Upravlja instancama adaptera.
 *
 * @package Ak\Image\Processor\Adapter
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/image-processor
 */
final class AdapterPluginManager extends AbstractPluginManager
{
    const CONFIG_KEY = 'image_processor_adapters';

    /** @var string */
    protected $instanceOf = AdapterInterface::class;
    /** @var array */
    protected $aliases = [
        'adapter_chain' => AdapterChain::class,
        'imagick'       => ImagickAdapter::class,
        'pass_through'  => PassThroughAdapter::class,
    ];
    /** @var array */
    protected $factories = [
        AdapterChain::class       => AdapterChainFactory::class,
        ImagickAdapter::class     => ImagickAdapterFactory::class,
        PassThroughAdapter::class => InvokableFactory::class,
    ];
}
