<?php
namespace Ak\Image\Processor\Adapter;

use Ak\Image\Image;
use Ak\Image\ImageInterface;
use Ak\Image\Processor\ResizeMode;

/**
 * Ovaj adapter ne radi baš ništa.
 *
 * @package Ak\Image\Processor\Adapter
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/image-processor
 */
final class PassThroughAdapter implements AdapterInterface
{
    /**
     * Da li ovaj adapter može obraditi datu sliku?
     *
     * @param ImageInterface $image
     * @return bool
     */
    public function canProcessImage(ImageInterface $image): bool
    {
        return true;
    }

    /**
     * Optimizira datu sliku.
     *
     * @param ImageInterface $image
     * @return ImageInterface
     */
    public function optimize(ImageInterface $image): ImageInterface
    {
        return new Image($image->getStream());
    }

    /**
     * Mijenja veličinu slike.
     *
     * @param ImageInterface $image
     * @param int|null $width
     * @param int|null $height
     * @param ResizeMode|null $mode
     * @return ImageInterface
     */
    public function resize(ImageInterface $image, int $width = null, int $height = null, ResizeMode $mode = null): ImageInterface
    {
        return new Image($image->getStream());
    }
}