<?php
namespace Ak\Image\Processor;

use Ak\Image\ImageInterface;

/**
 * Obrađuje slike.
 *
 * @package Ak\Image\Processor
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/image-processor
 */
interface ProcessorInterface
{
    /**
     * Da li ovaj procesor može obraditi datu sliku?
     *
     * @param ImageInterface $image
     * @return bool
     */
    public function canProcessImage(ImageInterface $image): bool;

    /**
     * Optimizira datu sliku.
     *
     * @param ImageInterface $image
     * @return ImageInterface
     */
    public function optimize(ImageInterface $image): ImageInterface;

    /**
     * Mijenja veličinu slike.
     *
     * @param ImageInterface $image
     * @param int|null $width
     * @param int|null $height
     * @param ResizeMode|null $mode
     * @return ImageInterface
     */
    public function resize(ImageInterface $image, int $width = null, int $height = null, ResizeMode $mode = null): ImageInterface;
}