<?php
namespace Ak\Image\Processor;

use Ak\Lib\Type\Enum;

/**
 * Načini mijenjanja veličine slike.
 *
 * @package Ak\Image\Processor
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/image-processor
 *
 * @method static ResizeMode DEFAULT()
 * @method static ResizeMode FIT()
 * @method static ResizeMode SCALE()
 * @method static ResizeMode THUMB()
 */
final class ResizeMode extends Enum
{
    // Ako su date obje dimenzije slika će biti redimenzionirana
    // proporcionalno dok nijedna dimenzija neće prijeći date.
    const FIT   = 'fit';
    // Ako je data samo jedna dimenzija, slika će biti redimenzionirana
    // proporcionalno tako da je data dimenzija date dimenzije ...
    const SCALE = 'scale';
    // Redimenzionirana slika će biti točno datih dimenzija ali će
    // biti odrezana ili nadopunjena tako da sadržaj ispunjava sliku.
    const THUMB = 'thumb';

    const DEFAULT = self::THUMB;
}